import { __assign, __rest } from "tslib";
import classNames from "classnames";
import React, { useRef } from "react";
import { Dropdown, OptionsContext, OptionStateContext, useNnavigate, useOptions, ValueContext } from "xy-select";
import "xy-select/assets/index.css";
import Trigger from "xy-trigger";
import AutoCompleteInput from "./AutoCompleteInput";
import useValue from "./Hooks/useValue";
import useVisible from "./Hooks/useVisible";
import Suggest from "./Suggest";
var ACTION = [];
var POPUPALIGN = { overflow: { adjust: false, flip: true } };
export var AutoComplete = React.forwardRef(function (props, ref) {
    var _a;
    var _b = props.prefixCls, prefixCls = _b === void 0 ? "xy-autocomplete" : _b, className = props.className, popupClassName = props.popupClassName, _c = props.stretch, stretch = _c === void 0 ? true : _c, style = props.style, backfill = props.backfill, children = props.children, filter = props.filter, _d = props.dataSource, dataSource = _d === void 0 ? [] : _d, empyPlaceholder = props.empyPlaceholder, customItem = props.customItem, onChange = props.onChange, onSelect = props.onSelect, onSearch = props.onSearch, inputProps = __rest(props, ["prefixCls", "className", "popupClassName", "stretch", "style", "backfill", "children", "filter", "dataSource", "empyPlaceholder", "customItem", "onChange", "onSelect", "onSearch"]);
    if (!ref) {
        ref = useRef(null);
    }
    var align = useRef(null);
    var lastValue = useRef(null);
    var _e = useOptions(false), options = _e[0], optionsContextRef = _e[1], _ = _e[2], cacheSelectCfg = _e[3];
    var _f = useVisible(props, lastValue), visible = _f[0], setVisible = _f[1], handleFocus = _f[2], handleBlur = _f[3], whenPickerHiden = _f[4];
    var _g = useValue(props, cacheSelectCfg, align, whenPickerHiden, lastValue, visible), value = _g[0], searchChangeHandle = _g[1], onOptionSelect = _g[2], compositionStartHandle = _g[3], compositionEndHandle = _g[4], searchRef = _g[5];
    var _h = useNnavigate(options, value, onOptionSelect, setVisible, true), focusValue = _h[0], handleKeyDown = _h[1], scrollwrapRef = _h[2];
    var classString = classNames(prefixCls, className, (_a = {},
        _a[prefixCls + "-visible"] = false,
        _a[prefixCls + "-disabled"] = props.disabled,
        _a));
    function renderInput() {
        var _inputProps = __assign(__assign({}, inputProps), { className: "autocompolete-inputbox", value: value, onKeyDown: handleKeyDown, onChange: searchChangeHandle, onBlur: handleBlur, onFocus: handleFocus, onCompositionStart: compositionStartHandle, onCompositionEnd: compositionEndHandle, ref: ref });
        if (children) {
            return React.cloneElement(children, _inputProps);
        }
        else {
            return React.createElement(AutoCompleteInput, __assign({}, _inputProps));
        }
    }
    function renderDropdown() {
        return (React.createElement(OptionStateContext.Provider, { value: { focusValue: focusValue, filter: filter, search: "filter" in props ? null : searchRef.current } },
            React.createElement(OptionsContext.Provider, { value: optionsContextRef.current },
                React.createElement(Dropdown, { placeholder: empyPlaceholder, scrollwrapRef: scrollwrapRef },
                    React.createElement(Suggest, { prefixCls: prefixCls, suggestions: dataSource, customItem: customItem })))));
    }
    return (React.createElement(ValueContext.Provider, { value: { value: value, onSelect: onOptionSelect } },
        React.createElement(Trigger, { prefixCls: "xy-select-transition", visible: visible, onChange: setVisible, alignRef: align, action: ACTION, popupAlign: POPUPALIGN, popupClassName: popupClassName, stretch: stretch, popup: renderDropdown() },
            React.createElement("div", { className: classString, style: style }, renderInput()))));
});
export default React.memo(AutoComplete);
//# sourceMappingURL=AutoComplete.js.map