import { __assign, __rest } from "tslib";
import classNames from "classnames";
import React, { useRef } from "react";
import { useControll } from "utils-hooks";
export var AutoCompleteInput = React.forwardRef(function (props, ref) {
    var _a;
    var prefixCls = props.prefixCls, className = props.className, style = props.style, disabled = props.disabled, onChange = props.onChange, rest = __rest(props, ["prefixCls", "className", "style", "disabled", "onChange"]);
    if (!ref) {
        ref = useRef(null);
    }
    var inputPrefixCls = "xy-autocomplete-inputwrap";
    var _b = useControll(props, "value", "defaultValue", ""), value = _b[0], setValue = _b[1], isControll = _b[2];
    var classString = classNames(inputPrefixCls, className, (_a = {},
        _a[inputPrefixCls + "-disabled"] = disabled,
        _a));
    function changeHandle(event) {
        var val = event.target.value;
        if (!isControll) {
            setValue(val);
        }
        if (onChange) {
            onChange(val);
        }
    }
    return (React.createElement("div", { className: classString, style: style },
        React.createElement("input", __assign({ type: "text", disabled: disabled, className: classNames(inputPrefixCls + "-input", className), onCompositionStart: function (e) { return null; }, "aria-disabled": disabled }, rest, { ref: ref }, (isControll ? { value: value || "" } : { defaultValue: value }), { onChange: changeHandle }))));
});
export default React.memo(AutoCompleteInput);
//# sourceMappingURL=AutoCompleteInput.js.map