import { useControll, useDebounceCallback } from "utils-hooks";
import { useRef, useLayoutEffect } from "react";
export default function useValue(props, cacheSelectCfg, align, onPicker, lastValue, visible) {
    var backfill = props.backfill, disabled = props.disabled, onChange = props.onChange, onSelect = props.onSelect, onSearch = props.onSearch, _a = props.delay, delay = _a === void 0 ? 200 : _a;
    var _b = useControll(props, "value", "defaultValue"), value = _b[0], setValue = _b[1], isControll = _b[2];
    var typingRef = useRef(false);
    var searchRef = useRef("");
    var pickerRef = useRef(null);
    useDebounceCallback(function () {
        if (onSearch) {
            if (backfill) {
                if (typingRef.current === false) {
                    onSearch(value);
                }
            }
            else {
                onSearch(value);
            }
        }
    }, delay, [searchRef.current]);
    function compositionStartHandle(e) {
        typingRef.current = true;
    }
    function compositionEndHandle(e) {
        typingRef.current = false;
    }
    function changeValue(val) {
        if (disabled) {
            return;
        }
        lastValue.current = val;
        if (!isControll) {
            setValue(val);
        }
        if (onChange) {
            onChange(val);
        }
    }
    function searchChangeHandle(val) {
        searchRef.current = val;
        changeValue(val);
    }
    // Tips: 搜索改变会影响推荐列表的数量, 所以需要重新对齐
    useLayoutEffect(function () {
        if (align.current) {
            align.current(false);
        }
    }, [value]);
    // Tips: 选择option后，等待下拉列表关闭动画完毕再设置search, 避免下拉列表内容和高度变化了，再执行动画
    useLayoutEffect(function () {
        if (pickerRef.current) {
            searchRef.current = pickerRef.current;
            pickerRef.current = null;
        }
    }, [visible]);
    /**
     * 选中option
     * @param _value
     */
    function optionSelectHandle(_value) {
        var optionCfg = cacheSelectCfg.current.get(_value);
        var val = (optionCfg && optionCfg.label) || (_value === undefined || _value === null ? null : _value + "");
        pickerRef.current = val;
        onPicker(val);
        changeValue(val);
        if (onSelect) {
            onSelect(val, optionCfg);
        }
    }
    return [value, searchChangeHandle, optionSelectHandle, compositionStartHandle, compositionEndHandle, searchRef];
}
//# sourceMappingURL=useValue.js.map