import { useEffect, useRef, useState } from "react";
export default function useVisible(props, lastValue) {
    var _a = props.dataSource, dataSource = _a === void 0 ? [] : _a, onBlur = props.onBlur;
    var _b = useState(false), visible = _b[0], setVisible = _b[1];
    var lastPicker = useRef(null);
    var focusRef = useRef(false);
    var empty = !dataSource || (dataSource instanceof Array && dataSource.length <= 0);
    // Tips: 当前焦点时, options 更新了, 也要判断是否收起下拉列表
    useEffect(function () {
        if (lastPicker.current) {
            if (focusRef.current && lastPicker.current !== lastValue.current) {
                handleFocus();
            }
        }
        else if (focusRef.current) {
            handleFocus();
        }
    }, [dataSource, lastValue.current]);
    function handleFocus() {
        if (empty) {
            focusRef.current = true;
        }
        if (!empty && !props.disabled) {
            focusRef.current = true;
            setVisible(true);
        }
    }
    function whenPickerHiden(val) {
        lastPicker.current = val;
        setVisible(false);
    }
    function handleBlur(e) {
        focusRef.current = false;
        setVisible(false);
        if (onBlur) {
            onBlur(e);
        }
    }
    return [visible, setVisible, handleFocus, handleBlur, whenPickerHiden];
}
//# sourceMappingURL=useVisible.js.map